# coding: utf-8

"""
    Veeroute.LSS Lastmile

    Veeroute.LSS Lastmile API  # noqa: E501

    The version of the OpenAPI document: 3.8.168904
    Contact: support@veeroute.com
    Generated by: https://openapi-generator.tech
"""


import inspect
import pprint
import re  # noqa: F401
import six

from vrt_lss_lastmile.configuration import Configuration


class OrderFact(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'type': 'str',
        'time': 'datetime',
        'order_key': 'str',
        'demand_facts': 'list[DemandFact]'
    }

    attribute_map = {
        'type': 'type',
        'time': 'time',
        'order_key': 'order_key',
        'demand_facts': 'demand_facts'
    }

    def __init__(self, type=None, time=None, order_key=None, demand_facts=None, local_vars_configuration=None):  # noqa: E501
        """OrderFact - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._type = None
        self._time = None
        self._order_key = None
        self._demand_facts = None
        self.discriminator = None

        self.type = type
        self.time = time
        self.order_key = order_key
        if demand_facts is not None:
            self.demand_facts = demand_facts

    @property
    def type(self):
        """Gets the type of this OrderFact.  # noqa: E501

        Fact type.  # noqa: E501

        :return: The type of this OrderFact.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this OrderFact.

        Fact type.  # noqa: E501

        :param type: The type of this OrderFact.  # noqa: E501
        :type type: str
        """
        if self.local_vars_configuration.client_side_validation and type is None:  # noqa: E501
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501
        allowed_values = ["DONE", "CANCEL", "PROGRESS"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and type not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def time(self):
        """Gets the time of this OrderFact.  # noqa: E501

        Fact time in the [RFC 3339, section 5.6](https://tools.ietf.org/html/rfc3339#section-5.6) format.  # noqa: E501

        :return: The time of this OrderFact.  # noqa: E501
        :rtype: datetime
        """
        return self._time

    @time.setter
    def time(self, time):
        """Sets the time of this OrderFact.

        Fact time in the [RFC 3339, section 5.6](https://tools.ietf.org/html/rfc3339#section-5.6) format.  # noqa: E501

        :param time: The time of this OrderFact.  # noqa: E501
        :type time: datetime
        """
        if self.local_vars_configuration.client_side_validation and time is None:  # noqa: E501
            raise ValueError("Invalid value for `time`, must not be `None`")  # noqa: E501

        self._time = time

    @property
    def order_key(self):
        """Gets the order_key of this OrderFact.  # noqa: E501

        Order key.  # noqa: E501

        :return: The order_key of this OrderFact.  # noqa: E501
        :rtype: str
        """
        return self._order_key

    @order_key.setter
    def order_key(self, order_key):
        """Sets the order_key of this OrderFact.

        Order key.  # noqa: E501

        :param order_key: The order_key of this OrderFact.  # noqa: E501
        :type order_key: str
        """
        if self.local_vars_configuration.client_side_validation and order_key is None:  # noqa: E501
            raise ValueError("Invalid value for `order_key`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                order_key is not None and len(order_key) > 1024):
            raise ValueError("Invalid value for `order_key`, length must be less than or equal to `1024`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                order_key is not None and len(order_key) < 1):
            raise ValueError("Invalid value for `order_key`, length must be greater than or equal to `1`")  # noqa: E501

        self._order_key = order_key

    @property
    def demand_facts(self):
        """Gets the demand_facts of this OrderFact.  # noqa: E501

        List of demand's facts.  # noqa: E501

        :return: The demand_facts of this OrderFact.  # noqa: E501
        :rtype: list[DemandFact]
        """
        return self._demand_facts

    @demand_facts.setter
    def demand_facts(self, demand_facts):
        """Sets the demand_facts of this OrderFact.

        List of demand's facts.  # noqa: E501

        :param demand_facts: The demand_facts of this OrderFact.  # noqa: E501
        :type demand_facts: list[DemandFact]
        """

        self._demand_facts = demand_facts

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = inspect.getargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OrderFact):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OrderFact):
            return True

        return self.to_dict() != other.to_dict()
