# coding: utf-8

"""
    Veeroute.LSS Lastmile

    Veeroute.LSS Lastmile API  # noqa: E501

    The version of the OpenAPI document: 3.8.168904
    Contact: support@veeroute.com
    Generated by: https://openapi-generator.tech
"""


import inspect
import pprint
import re  # noqa: F401
import six

from vrt_lss_lastmile.configuration import Configuration


class Routing(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'transport_type': 'TransportType',
        'matrix': 'RoutingMatrix',
        'traffic_jams': 'list[TrafficFactor]'
    }

    attribute_map = {
        'transport_type': 'transport_type',
        'matrix': 'matrix',
        'traffic_jams': 'traffic_jams'
    }

    def __init__(self, transport_type=None, matrix=None, traffic_jams=None, local_vars_configuration=None):  # noqa: E501
        """Routing - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._transport_type = None
        self._matrix = None
        self._traffic_jams = None
        self.discriminator = None

        self.transport_type = transport_type
        self.matrix = matrix
        if traffic_jams is not None:
            self.traffic_jams = traffic_jams

    @property
    def transport_type(self):
        """Gets the transport_type of this Routing.  # noqa: E501


        :return: The transport_type of this Routing.  # noqa: E501
        :rtype: TransportType
        """
        return self._transport_type

    @transport_type.setter
    def transport_type(self, transport_type):
        """Sets the transport_type of this Routing.


        :param transport_type: The transport_type of this Routing.  # noqa: E501
        :type transport_type: TransportType
        """
        if self.local_vars_configuration.client_side_validation and transport_type is None:  # noqa: E501
            raise ValueError("Invalid value for `transport_type`, must not be `None`")  # noqa: E501

        self._transport_type = transport_type

    @property
    def matrix(self):
        """Gets the matrix of this Routing.  # noqa: E501


        :return: The matrix of this Routing.  # noqa: E501
        :rtype: RoutingMatrix
        """
        return self._matrix

    @matrix.setter
    def matrix(self, matrix):
        """Sets the matrix of this Routing.


        :param matrix: The matrix of this Routing.  # noqa: E501
        :type matrix: RoutingMatrix
        """

        self._matrix = matrix

    @property
    def traffic_jams(self):
        """Gets the traffic_jams of this Routing.  # noqa: E501

        Time and distance coefficients for a specific time period to account for traffic.  # noqa: E501

        :return: The traffic_jams of this Routing.  # noqa: E501
        :rtype: list[TrafficFactor]
        """
        return self._traffic_jams

    @traffic_jams.setter
    def traffic_jams(self, traffic_jams):
        """Sets the traffic_jams of this Routing.

        Time and distance coefficients for a specific time period to account for traffic.  # noqa: E501

        :param traffic_jams: The traffic_jams of this Routing.  # noqa: E501
        :type traffic_jams: list[TrafficFactor]
        """
        if (self.local_vars_configuration.client_side_validation and
                traffic_jams is not None and len(traffic_jams) > 24):
            raise ValueError("Invalid value for `traffic_jams`, number of items must be less than or equal to `24`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                traffic_jams is not None and len(traffic_jams) < 0):
            raise ValueError("Invalid value for `traffic_jams`, number of items must be greater than or equal to `0`")  # noqa: E501

        self._traffic_jams = traffic_jams

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = inspect.getargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Routing):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Routing):
            return True

        return self.to_dict() != other.to_dict()
